
/*  @(#)mimepps.c 1.2 95/07/07
 *
 *  Copyright (c) Mikael Cam.
 *                All rights reserved.
 *
 *  Permission is given to distribute these sources, as long as the
 *  copyright messages are not removed, and no monies are exchanged.
 *
 *  No responsibility is taken for any errors inherent either
 *  to the comments or the code of this program, but if reported
 *  to me then an attempt will be made to fix them.
 */

#define _TRACE  0
#define MAXLINE 4096
#define MAXARRAY 1024
#define EOS '\0'
#define MIMEPOUT "MIMEPOUT"
#define MIMEPBOUND "MIMEPBOUND"
#define MIMEPRULEH "MIMEPRULEH"
#define DEFAULTB   "default"
#define NOB        "none"
#define TMPREFIX   "MIMEP"
#define TMPDIR     "/tmp"
#define PSVERSION1 "%!PS-Adobe-1.0\n"
#define PSVERSION2 "%!PS-Adobe-2.0\n"
#define PSVERSION2EPSF "%!PS-Adobe-2.0 EPSF-2.0\n"
#define PSEND1 "xt\n\nxs\n"
#define PSEND2 "end\nuserdict /end-hook known{end-hook}if\n%%EOF"
#define PAGEBEG "%%Page:"
#define ENDDOC  "%%Trailer"
#define EPSSUFFIX ".eps"
#define NOTHING   ""
#define T( toto ) fprintf(stderr, "%s\n", toto)

#include <stdio.h>
#include <string.h>
#include <stdlib.h>
#define  True   1
#define  False  0

char *usage = "Usage: mimepps [input_file] (else stdin)\n";

int cutps(char *filename)
{

  char *ERR[] = 
    {
      "Erreur lors de l'ouverture du fichier source\n",
      "Impossible de lire la variable MIMEPOUT...\n",
      "Erreur lors de l'ouverture du fichier cible...\n",
      "Erreur lors de l'ouverture du fichier prologue temporaire...\n",
      "Version de fichier Postcript inconnue...\n",
      "Erreur lors de l'ouverture d'un fichier temporaire!\n"
    };	  



  FILE *fp;
  char *prologfilename;
  FILE *prologfp;
  int  PSVersion;
  char *mimepout;
  FILE *mimepfp;
  static char pagefilename[MAXARRAY];
  FILE *pagefp;
  char lignecour[MAXLINE];
  char TheEnd;
  char *boundary;
  char *RULEH;

  if(!(mimepout = getenv(MIMEPOUT)))
    {
      fprintf(stderr, ERR[1]);
      exit(1);
    }

  if(!(mimepfp = fopen(mimepout, "a")))
       {
	fprintf(stderr, "%s", ERR[2]);
	exit(1);
      } 
   

  if(!strcmp(filename, "stdin")) fp = stdin;
  else
    if (!(fp = fopen(filename, "r")))
      {
	fprintf(stderr, "%s", ERR[0]);
	exit(1);
      } 
  

  prologfilename =  tempnam(TMPDIR, TMPREFIX);
  
    if(!(prologfp = fopen(prologfilename, "w")))
       {
	fprintf(stderr, "%s", ERR[3]);
	exit(1);
      } 



  if (_TRACE) T("Fichiers ouverts!");
  
  if(!fgets(lignecour, MAXLINE, fp)) lignecour[0] = EOS;
  
  if(_TRACE) fprintf(stderr, "PSVERSION: %s\n", lignecour);
  
  if(!strcmp(lignecour, PSVERSION1)) PSVersion = 1;
  else 
    if(!strcmp(lignecour, PSVERSION2)) PSVersion = 2;
    else
      if(!strcmp(lignecour, PSVERSION2EPSF)) PSVersion = 3;
      else
	{
	  fprintf(stderr, ERR[4]);
	  exit(1);
	}
  fprintf(prologfp, "%s", lignecour);
  
  
  while(!feof(fp))
    {
      if(!fgets(lignecour, MAXLINE, fp)) lignecour[0] = EOS; 
      if(!strncmp(lignecour, PAGEBEG, strlen(PAGEBEG))) break;
      fprintf(prologfp, "%s", lignecour);
    }
  
  fclose(prologfp);
  
  TheEnd = False;
  
  while(!TheEnd)
    {
      

      if(!(prologfp = fopen(prologfilename, "r")))
	{
	  fprintf(stderr, "%s", ERR[3]);
	  exit(1);
	} 

      strcpy(pagefilename, tempnam(TMPDIR, TMPREFIX));
      strcat(pagefilename, EPSSUFFIX);

      if(!(pagefp = fopen(pagefilename, "w")))
	{
	  fprintf(stderr, "%s", ERR[5]);
	  exit(1);
	} 
      
      while(!feof(prologfp))
	{
	  if(!fgets(lignecour, MAXLINE, prologfp)) lignecour[0] = EOS; 
	  fprintf(pagefp, "%s", lignecour);
	}
      
      fclose(prologfp);
      
      while((!feof(fp)) && (!TheEnd))
	{
	  if(!fgets(lignecour, MAXLINE, fp)) lignecour[0] = EOS; 
	  if(!strncmp(lignecour, PAGEBEG, strlen(PAGEBEG))) break;
	  else
	    if(!strncmp(lignecour, ENDDOC, strlen(ENDDOC))) TheEnd = True;
	  fprintf(pagefp, "%s", lignecour);
	}
      if(feof(fp)) TheEnd = True;
      fprintf(pagefp, "%s", 
	      (PSVersion == 1) ? PSEND1 : (PSVersion == 2) ? PSEND2 : NOTHING);
      fclose(pagefp);
      fprintf(mimepfp, "\\centerline{\\includegraphics{%s}}\n", pagefilename);
    }
  fclose(fp);

  if(boundary = getenv(MIMEPBOUND))
    {
      	 if (strcmp(boundary, NOB))
	   {

	     if (!strcmp(boundary, DEFAULTB))
	       if(RULEH = getenv(MIMEPRULEH))
		 fprintf(mimepfp, "\\centerline{\\rule{\\textwidth}{%spt}}\n", RULEH);
	     else
	       if (fp = fopen(boundary, "r"))
		 {
		   fclose(fp);
		   fprintf(mimepfp, "\\centerline{\\includegraphics{%s}}\n", boundary);
		 }
	       

	   }
       }






  fclose(mimepfp);
  exit(0);
  
}

int main(int argc, char *argv[])
{
  char fichier[50];
  switch (argc)
    {
    case 1: strcpy(fichier, "stdin"); break;
    case 2: strcpy(fichier, argv[1]); break;
    default: fprintf(stderr, "%s", usage); exit(1);
    }
  cutps(fichier);
}








