
/*  @(#)cutlines.c 1.3 95/07/07
 *
 *  Copyright (c) Mikael Cam.
 *                All rights reserved.
 *
 *  Permission is given to distribute these sources, as long as the
 *  copyright messages are not removed, and no monies are exchanged.
 *
 *  No responsibility is taken for any errors inherent either
 *  to the comments or the code of this program, but if reported
 *  to me then an attempt will be made to fix them.
 */

/* This command wraps the lines of a text.
 * The maximum length of a line is determined with the environment variable
 * MIMEPMAXCH, initialized by Mimep.
 */

#define _TRACE  0
#define MIMEPMAXCH "MIMEPMAXCH"
#define DEFMAXCAR  80
#define MAXLINE 4096
#define EOS '\0'
#define SPACE ' '
#define TAB '\t'
#define T( toto ) fprintf(stderr, "%s\n", toto)

#include <stdio.h>
#include <string.h>
#include <stdlib.h>
#define  True   1
#define  False  0

char *usage = "Usage: cutlines [input_file] (else stdin)\n";

int cutlines(char *filename)
{

  char *ERR[] = {
                "Erreur lors de l'ouverture du fichier source\n"
	       };	  



  FILE *fp;
  char carcour;
   int i, j;
  int ind = 0;
  char Trouve;
  char *maxchstr;
  int  maxcar;
  char lignecour[MAXLINE];
  int lastspace,
      lastCR;
  char *souschaine;

 



  if (!(maxchstr = getenv (MIMEPMAXCH)))
      maxcar = DEFMAXCAR;
  else
    maxcar = (int) strtol (maxchstr, NULL, 10);
    
  if(_TRACE) fprintf(stderr, "Maxcar: %d\n", maxcar);

  if(!strcmp(filename, "stdin")) fp = stdin;
  else
    if (!(fp = fopen(filename, "r"))) {
      fprintf(stderr, "%s", ERR[0]);
      exit(1);
    } 
  
  if (_TRACE) T("Fichier ouvert!");
  
  
  while (!feof(fp)) 
    {
     if(!fgets(lignecour, MAXLINE, fp)) lignecour[0] = EOS; 
    
      if (strlen (lignecour) <= maxcar)
	fprintf (stdout, "%s", lignecour);
      else
	{
	  j = 0;
	  
	  lastCR = 0;
	  
	  lastspace = 0;
	  
	  while(lignecour [lastCR + j] != EOS)
	    {
	      
	      carcour = lignecour[lastCR + j];
	      
	      if ((carcour == SPACE) || (carcour == TAB)) lastspace = j;
	      
	      if (j > maxcar - 1) 
		{
		  
		  if (lastspace)

		    {
		      souschaine = (char *) malloc (sizeof (char) * (lastspace + 1));
		      
		      strncpy (souschaine, lignecour + lastCR, lastspace);
		      
		      souschaine[lastspace] = EOS;

		      fprintf (stdout, "%s\n", souschaine); 
		      
		      lastCR = lastCR + lastspace + 1;
		      
		      j = 0;
		      
		      lastspace = 0;
		      
		    }
		  else
		    {
		      souschaine = (char *) malloc (sizeof (char) * (j + 1));
		      
		      strncpy (souschaine, lignecour + lastCR, j);
		      
		      souschaine[j] = EOS;

		      fprintf (stdout, "%s\n", souschaine); 
		      
		      lastCR = lastCR + j;
		      
		      j = 0;
		      
		      lastspace = 0;
		      
		    }
		  
		  free(souschaine);

		}
	    else
	      {
	      if (lignecour[lastCR + j + 1] == EOS) 
		{
		  
		  souschaine = (char *) malloc (sizeof (char) * (j + 1));
		      
		  strncpy (souschaine, lignecour + lastCR, j + 1);
		  souschaine[j] = EOS; 
		  
		  fprintf (stdout, "%s\n", souschaine); 
		  
		  free(souschaine);
		}
	      
		j++;	
	    }
	  }
	}
    }
  
}

int main(int argc, char *argv[])
{
  char fichier[50];
  switch (argc)
    {
    case 1: strcpy(fichier, "stdin"); break;
    case 2: strcpy(fichier, argv[1]); break;
    default: fprintf(stderr, "%s", usage); exit(1);
    }
  cutlines(fichier);
}








