.\" @(#)mptool.man 1.4 94/02/03
.TH MPTOOL 1 "4 January 1994"
.ds Ps P\s-2OST\s+2S\s-2CRIPT\s+2
.SH NAME
.\" don't use Ps register in line below; goofs up output from whatis command
mptool \- a Motif window-based front-end to the mp POSTSCRIPT pretty printer
program.
.SH SYNOPSIS
The
.I mptool
program has the same command line options as the
.I mp
program. See those manual pages for more details.
.SH DESCRIPTION
The
.I mp
program is used to pretty print mail, news articles or ordinary text files.
There are now lots of command line options to
.I mp
which can be used to setup various options to change the way the text is
output. These are not always easy to remember. The
.I mptool
program is provided as a simpler means of setting these options and thereby
making it easier to print your files in the desired format.
.LP
It is also possible to select text in another Motif application, and drag and
drop that text over the
.I mptool
open window, and it will be automatically printed out using the current
settings.
.SH OPTIONS
The
.I mptool
program has the same command line options as the
.I mp
program. See those manual pages for more details.
.SH RESOURCES
.PP
On startup,
.B mptool
look for various X resources which by default are stored in
.B $HOME/.mpdefaults.
Note these resource names will be prepended with
.B mptool.
All of these X resources are described in the
.I mp
manual pages.
.SH USAGE
.I mptool
operates via a set of graphical items both in the main window and the various
option sheets. Commonly used operations are easily accessable via options
in the main window; the remainder are on the option sheets. Each option
equates to an
.I mp
command line option. This section gives the match up between these graphical
options and the equivalent
.I mp
command line option. Refer to the
.I mp
manuals pages for more details on each option.
.sp
.RS
.TP 15
.B Filenames:
The file(s) to be printed.
.sp
.\"======================================================================
.TP 15
.B Input type:
Nothing, "-news", "-postscript" or "-text", depending upon the setting.
.sp
.\"======================================================================
.TP 15
.B Output type:  
Nothing, "-landscape" or an Organiser type (see below).
.sp
.\"======================================================================
.TP 15
.B Organiser:
"-filofax", "-franklin", "-proplan", "-timeman", "-tsintl" or "-tspartner"
depending upon the organiser type selected.
.sp
.\"======================================================================
.TP 15
.B Paper Size:
Nothing, "-a4" or "-us".
.sp
.\"======================================================================
.TP 15
.B Subject:
Nothing or "-subject <subject>".
.sp
.\"======================================================================
.TP 15
.B Copies:
"-copies #".
.sp
.\"======================================================================
.TP 15
.B Number of Sides:
Nothing or "-duplex".
.sp
.\"======================================================================
.RE
.PP
Clicking on the Print button causes
.I mptool
to execute an
.I mp
job with the various command line settings. Clicking on the Reset button will
reset all the options to their default values.
.sp
.PP
Note that the Filename: field can contain multiple filenames. These should be
separated by spaces. If any of the filenames contain a space character, then
this filename needs to be quoted.
.sp
.PP
There are various option property windows. The Header options window contains
the following options:
.sp
.RS
.\"======================================================================
.TP 15
.B Print all headers:
"-allhdrs".
.sp
.\"======================================================================
.TP 15
.B Headers to Print:
"-addhdr <header>" or "-remhdr <header>" depending upon whether the header
is a new one added by the user, or a default one that was removed from the
initial list.
.sp
.RE
.\"======================================================================
.PP
The Input options window contains the following options:
.sp
.RS
.\"======================================================================
.TP 15
.B Prologue Name:
nothing or "-prologue <name>".
.sp
.\"======================================================================
.TP 15
.B Mail folder
Nothing or "-folder".
.sp
.\"======================================================================
.TP 15
.B Mail digest
Nothing or "-digest".
.sp
.\"======================================================================
.TP 15
.B Elm mail file:
nothing or "-elm".
.sp
.\"======================================================================
.TP 15
.B Use From header:
nothing or "-from".
.sp
.\"======================================================================
.TP 15
.B Use Content-Length: field:
nothing or "-content".
.sp
.\"======================================================================
.TP 15
.B Use file last modification time:
nothing or "-modtime".
.sp 
.RE
.\"======================================================================
.PP
The Output options window contains the following options:
.sp
.RS
.\"======================================================================
.TP 15
.B Printer Name:
"-printer" or "-printer <name> depending upon whether a printer name was given.
.sp
.\"======================================================================
.TP 15
.B Line Length:
"-linelength #".
.sp
.\"======================================================================
.TP 15
.B Page Length:
"-pagelength #".
.sp
.\"======================================================================
.TP 15
.B Output to BSD printer system:
"-bsdprint".
.sp
.RE
.\"======================================================================
.PP
The Printing options window contains the following options:
.sp 
.RS
.\"======================================================================
.TP 15
.B Columns per Page:
"-columns #".
.sp
.\"======================================================================
.TP 15
.B Spaces per Tab Character:
"-tab #".
.sp
.\"======================================================================
.TP 15
.B Margins:
"-top #", "-left #", "-bottom #" and "-right #".
.sp
.\"====================================================================== 
.TP 15
.B Print header page
Nothing or "-banner".
.sp
.\"======================================================================
.TP 15
.B Wrap words onto next line of output:
nothing or "-wrap".
.sp
.\"======================================================================
.TP 15
.B Flip banner headings:
nothing or "-flip".
.sp
.\"======================================================================
.TP 15
.B Force new page:
nothing or "-forcepage".
.sp
.\"======================================================================
.TP 15
.B Number each line of output:
nothing or "-number".
.sp
.\"======================================================================
.TP 15
.B Adjust reverse page for duplex printing
nothing or "-tumble".
.sp
.RE
.\"====================================================================== 
.PP
The User Name options window contains the following options:
.sp
.RS
.\"======================================================================
.TP 15
.B Alias Name:
"-alias name".
.sp
.\"======================================================================
.TP 15
.B Characters in User Name:
"-chars #".
.sp
.\"======================================================================
.TP 15
.B Words in User Name:
"-words #".
.sp
.\"======================================================================
.RE
.PP
These options will only be applyed if you click on the Apply button on the
appropriate options sheet. Clicking on the Reset button on that property
sheet, resets those property sheet values back to their default values.
Clicking on the Save as Defaults option in the Options menu, causes all the
current option sheet settings to be the defaults the next time
.I mptool
is started.
.sp
.SH "ENVIRONMENT VARIABLES"
The default output printer is determined by looking at the.
.I PRINTER
environment variable for BSD systems or the
.I LPDEST
environment variable for System V systems.
.PP
An alternative file containing the
.I mptool
X resources can be given with the
.I MPDEFAULTS
environment variable.
.sp
.SH FILES
.TP
.I $HOME/.mpdefaults
X resource initialisation file.
.TP
.I BINDIR/mptool
executable
.sp
.SH "SEE ALSO"
.IR mp (1),
.IR lp (1),
.IR lpr (1)
.sp
.SH AUTHOR
Rich Burridge.  PHONE: (USA) (415) 336 6261  MAIL: richb@Eng.Sun.COM
